## zlib 1.2.3.3.dfsg

=== Makefile ===
# Makefile for zlib
# Copyright (C) 1995-2006 Jean-loup Gailly.
# For conditions of distribution and use, see copyright notice in zlib.h

# To compile and test, type:
#    ./configure; make test
# The call of configure is optional if you don't have special requirements
# If you wish to build zlib as a shared library, use: ./configure -s

# To use the asm code, type:
#    cp contrib/asm?86/match.S ./match.S
#    make LOC=-DASMV OBJA=match.o

# To install /usr/local/lib/libz.* and /usr/local/include/zlib.h, type:
#    make install
# To install in $HOME instead of /usr/local, use:
#    make install prefix=$HOME

CC=cc

CFLAGS=-O
#CFLAGS=-O -DMAX_WBITS=14 -DMAX_MEM_LEVEL=7
#CFLAGS=-g -DDEBUG
#CFLAGS=-O3 -Wall -Wwrite-strings -Wpointer-arith -Wconversion \
#           -Wstrict-prototypes -Wmissing-prototypes

SFLAGS=-O

LDFLAGS=libz.a
LDSHARED=$(CC)
CPP=$(CC) -E

LIBS=libz.a
SHAREDLIB=libz.so
SHAREDLIBV=libz.so.1.2.3.3
SHAREDLIBM=libz.so.1

AR=ar
RANLIB=ranlib
TAR=tar
SHELL=/bin/sh
EXE=

prefix = /usr/local
exec_prefix = ${prefix}
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include
mandir = ${prefix}/share/man
man3dir = ${mandir}/man3
pkgconfigdir = ${libdir}/pkgconfig

OBJC = adler32.o compress.o crc32.o gzio.o uncompr.o deflate.o trees.o \
       zutil.o inflate.o infback.o inftrees.o inffast.o

OBJA =
# to use the asm code: make OBJA=match.o

OBJS = $(OBJC) $(OBJA)

PIC_OBJS = $(OBJS:%.o=%.lo)

TEST_OBJS = example.o minigzip.o

allstatic: example$(EXE) minigzip$(EXE)

allshared: examplesh$(EXE) minigzipsh$(EXE)

all: allstatic allshared

teststatic: allstatic
	@echo hello world | ./minigzip | ./minigzip -d || \
	  echo '		*** minigzip test FAILED ***' ; \
	if ./example; then \
	  echo '		*** zlib test OK ***'; \
	else \
	  echo '		*** zlib test FAILED ***'; \
	fi

testshared: allshared
	@LD_LIBRARY_PATH=`pwd`:$(LD_LIBRARY_PATH) ; export LD_LIBRARY_PATH; \
	DYLD_LIBRARY_PATH=`pwd`:$(DYLD_LIBRARY_PATH) ; export DYLD_LIBRARY_PATH; \
	SHLIB_PATH=`pwd`:$(SHLIB_PATH) ; export SHLIB_PATH; \
	echo hello world | ./minigzipsh | ./minigzipsh -d || \
	  echo '		*** minigzip shared test FAILED ***' ; \
	if ./examplesh; then \
	  echo '		*** zlib shared test OK ***'; \
	else \
	  echo '		*** zlib shared test FAILED ***'; \
	fi

test: teststatic testshared

check: test

libz.a: $(OBJS)
	$(AR) $@ $(OBJS)
	-@ ($(RANLIB) $@ || true) >/dev/null 2>&1

match.o: match.S
	$(CPP) match.S > _match.s
	$(CC) -c _match.s
	mv _match.o match.o
	rm -f _match.s

match.lo: match.S
	$(CPP) match.S > _match.s
	$(CC) -c -fPIC _match.s
	mv _match.o match.lo
	rm -f _match.s

%.lo: %.c
	$(CC) $(SFLAGS) -DPIC -c $< -o $@

$(SHAREDLIBV): $(PIC_OBJS)
	$(LDSHARED) -o $@ $(PIC_OBJS) -lc
	rm -f $(SHAREDLIB) $(SHAREDLIBM)
	ln -s $@ $(SHAREDLIB)
	ln -s $@ $(SHAREDLIBM)

example$(EXE): example.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ example.o $(LDFLAGS)

minigzip$(EXE): minigzip.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ minigzip.o $(LDFLAGS)

examplesh$(EXE): example.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ example.o -L. $(SHAREDLIB)

minigzipsh$(EXE): minigzip.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ minigzip.o -L. $(SHAREDLIB)

install-libs: $(LIBS)
	-@if [ ! -d $(DESTDIR)$(exec_prefix)  ]; then mkdir -p $(DESTDIR)$(exec_prefix); fi
	-@if [ ! -d $(DESTDIR)$(libdir)       ]; then mkdir -p $(DESTDIR)$(libdir); fi
	-@if [ ! -d $(DESTDIR)$(man3dir)      ]; then mkdir -p $(DESTDIR)$(man3dir); fi
	-@if [ ! -d $(DESTDIR)$(pkgconfigdir) ]; then mkdir -p $(DESTDIR)$(pkgconfigdir); fi
	cp $(LIBS) $(DESTDIR)$(libdir)
	cd $(DESTDIR)$(libdir); chmod 755 $(LIBS)
	-@(cd $(DESTDIR)$(libdir); $(RANLIB) libz.a || true) >/dev/null 2>&1
	cd $(DESTDIR)$(libdir); if test -f $(SHAREDLIBV); then \
	  rm -f $(SHAREDLIB) $(SHAREDLIBM); \
	  ln -s $(SHAREDLIBV) $(SHAREDLIB); \
	  ln -s $(SHAREDLIBV) $(SHAREDLIBM); \
	  (ldconfig || true)  >/dev/null 2>&1; \
	fi
	cp zlib.3 $(DESTDIR)$(man3dir)
	chmod 644 $(DESTDIR)$(man3dir)/zlib.3
	cp zlib.pc $(DESTDIR)$(pkgconfigdir)
	chmod 644 $(DESTDIR)$(pkgconfigdir)/zlib.pc
# The ranlib in install is needed on NeXTSTEP which checks file times
# ldconfig is for Linux

install: install-libs
	-@if [ ! -d $(DESTDIR)$(includedir)   ]; then mkdir -p $(DESTDIR)$(includedir); fi
	cp zlib.h zconf.h zlibdefs.h $(DESTDIR)$(includedir)
	chmod 644 $(DESTDIR)$(includedir)/zlib.h $(DESTDIR)$(includedir)/zconf.h $(DESTDIR)$(includedir)/zlibdefs.h

uninstall:
	cd $(DESTDIR)$(includedir); rm -f zlib.h zconf.h zlibdefs.h
	cd $(DESTDIR)$(libdir); rm -f libz.a; \
	if test -f $(SHAREDLIBV); then \
	  rm -f $(SHAREDLIBV) $(SHAREDLIB) $(SHAREDLIBM); \
	fi
	cd $(DESTDIR)$(man3dir); rm -f zlib.3
	cd $(DESTDIR)$(pkgconfigdir); rm -f zlib.pc

mostlyclean: clean
clean:
	rm -f *.o *.lo *~ \
	   example$(EXE) minigzip$(EXE) examplesh$(EXE) minigzipsh$(EXE) \
	   libz.* foo.gz so_locations \
	   _match.s maketree contrib/infback9/*.o

maintainer-clean: distclean
distclean: clean
	cp -p Makefile.in Makefile
	rm zlibdefs.h
	touch -r configure zlibdefs.h
	rm -f zlib.pc .DS_Store

tags:
	etags *.[ch]

depend:
	makedepend -- $(CFLAGS) -- *.[ch]

# DO NOT DELETE THIS LINE -- make depend depends on it.

adler32.o: zlib.h zconf.h zlibdefs.h
compress.o: zlib.h zconf.h zlibdefs.h
crc32.o: crc32.h zlib.h zconf.h zlibdefs.h
deflate.o: deflate.h zutil.h zlib.h zconf.h zlibdefs.h
example.o: zlib.h zconf.h zlibdefs.h
gzio.o: zutil.h zlib.h zconf.h zlibdefs.h
inffast.o: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h
inflate.o: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h inffixed.h
infback.o: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h inffixed.h
inftrees.o: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h
minigzip.o: zlib.h zconf.h zlibdefs.h
trees.o: deflate.h zutil.h zlib.h zconf.h zlibdefs.h trees.h
uncompr.o: zlib.h zconf.h zlibdefs.h
zutil.o: zutil.h zlib.h zconf.h zlibdefs.h

adler32.lo: zlib.h zconf.h zlibdefs.h
compress.lo: zlib.h zconf.h zlibdefs.h
crc32.lo: crc32.h zlib.h zconf.h zlibdefs.h
deflate.lo: deflate.h zutil.h zlib.h zconf.h zlibdefs.h
gzio.lo: zutil.h zlib.h zconf.h zlibdefs.h
inffast.lo: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h
inflate.lo: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h inffixed.h
infback.lo: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h inflate.h inffast.h inffixed.h
inftrees.lo: zutil.h zlib.h zconf.h zlibdefs.h inftrees.h
trees.lo: deflate.h zutil.h zlib.h zconf.h zlibdefs.h trees.h
uncompr.lo: zlib.h zconf.h zlibdefs.h
zutil.lo: zutil.h zlib.h zconf.h zlibdefs.h

## zlib 1.2.3.4.dfsg

=== debian/changelog ===
zlib (1:1.2.3.4.dfsg-3ubuntu4) precise; urgency=low

  * Mark zlib1g-dev Multi-Arch: same as well, having confirmed that the
    contents are compatible.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Nov 2011 09:07:10 -0800

zlib (1:1.2.3.4.dfsg-3ubuntu3) natty; urgency=low

  * No-change rebuild against fixed pkgbinarymangler, to get correct
    multiarch-safe changelogs

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 21 Mar 2011 01:20:48 -0700

zlib (1:1.2.3.4.dfsg-3ubuntu2) natty; urgency=low

  * Build for multiarch and pre-depend on multiarch-support.
  * Install udeb contents to lib, not to the multiarch path.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 16 Mar 2011 15:32:41 -0700

zlib (1:1.2.3.4.dfsg-3ubuntu1) maverick; urgency=low

  * Merge from debian testing.  Remaining changes:
    - zlib.h: add z_off64_t and ensure that its mapped to the correct
      off_t or off64_t (fixes FTBFS in vips, gtk)
    - drop Conflicts on libc6-i386 (<= 2.9-18) because we do not have
      to do a /emul/ia32-linux -> /usr/lib32 transition

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 17 May 2010 18:06:51 +0200

zlib (1:1.2.3.4.dfsg-3) unstable; urgency=low

  * Only check for EOF on transparent streams if we have done a zero
    byte read to avoid reporting EOF early to applications.  This was
    breaking R.

 -- Mark Brown <broonie@debian.org>  Mon, 28 Dec 2009 19:00:35 +0000

zlib (1:1.2.3.4.dfsg-2) unstable; urgency=low

  * Revert explict EOF indication to avoid triggering an infinite loop
    in man-db while rebuilding the caches (closes: #562518).

 -- Mark Brown <broonie@debian.org>  Fri, 25 Dec 2009 15:02:23 +0000

zlib (1:1.2.3.4.dfsg-1) unstable; urgency=low

  * New upstream release.
  * This release contains refactored handling of 64 bit types which should
    stop warnings being generated in some configurations (closes: #439980).
  * This release also fixes handling of EOF in gzio (closes: #301283).
  * Fix symbol version for inflateUndermine.
  * Move -dbg to debug section.
  * Add upstream home page. 
  * Policy 3.8.3.

 -- Mark Brown <broonie@debian.org>  Thu, 24 Dec 2009 17:35:16 +0000

zlib (1:1.2.3.3.dfsg-16) unstable; urgency=low

  * Concert to 3.0 (quilt) format.

 -- Mark Brown <broonie@debian.org>  Tue, 08 Dec 2009 20:43:49 +0000

zlib (1:1.2.3.3.dfsg-15ubuntu1) lucid; urgency=low

  * Merge from debian unstable, remaining changes:
    - zlib.h: add z_off64_t and ensure that its mapped to the correct
      off_t or off64_t (fixes FTBFS in vips, gtk)
    - Move zlib.so.* to /lib.
    - drop Conflicts on libc6-i386 (<= 2.9-18) because we do not have
      to do a /emul/ia32-linux -> /usr/lib32 transition

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 09 Nov 2009 13:22:10 +0100

zlib (1:1.2.3.3.dfsg-15) unstable; urgency=low

  * Using Conflicts instead of Replaces for the amd64 lib32 transition
    since that's the latest idea for making it work (closes: #539278).

 -- Mark Brown <broonie@debian.org>  Tue, 04 Aug 2009 19:34:11 +0100

zlib (1:1.2.3.3.dfsg-14) unstable; urgency=low

  * amd64 has finally abandoned /emul/ia32-linux so install the 32 bit
    binaries in lib32 as for other architectures (closes: #533015).

 -- Mark Brown <broonie@debian.org>  Thu, 25 Jun 2009 12:49:05 +0100

zlib (1:1.2.3.3.dfsg-13ubuntu3) karmic; urgency=low

  * zlib.h:
    - add z_off64_t and ensure that its mapped to the correct
      off_t or off64_t (fixes FTBFS in vips, gtk)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 08 Sep 2009 10:39:15 +0200

zlib (1:1.2.3.3.dfsg-13ubuntu2) karmic; urgency=low

  * zlib.h:
    - add prototypes for the 64 bit functions if  
      _FILE_OFFSET_BITS=64 is defined (LP: #402178)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 24 Aug 2009 08:34:59 +0200

zlib (1:1.2.3.3.dfsg-13ubuntu1) karmic; urgency=low

  * Resynchronise with Debian. Remaining changes:
    - Do not move from /usr/lib32 to /emul/ia32-linux/ in lib32z1.
    - Move zlib.so.* to /lib.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 06 May 2009 15:05:27 +0100

zlib (1:1.2.3.3.dfsg-13) unstable; urgency=low

  * Add LPIA to the list of unaligned architectures to reduce the Ubuntu
    diff a little (closes: #517403).

 -- Mark Brown <broonie@debian.org>  Sun, 01 Mar 2009 20:43:18 +0000

zlib (1:1.2.3.3.dfsg-12ubuntu2) jaunty; urgency=low

  * Move zlib.so.* to /lib (LP: #44194).

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 18 Mar 2009 16:28:00 +0000

zlib (1:1.2.3.3.dfsg-12ubuntu1) intrepid; urgency=low

  * Merge from debian unstable, remaining changes:
    - Add lpia to the list of UNALIGNED_OK architectures.
    - Do not move from /usr/lib32 to /emul/ia32-linux/ in lib32z1

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 06 May 2008 12:02:39 +0200

zlib (1:1.2.3.3.dfsg-12) unstable; urgency=low

  * Apply patch from Arthur Loiret <arthur.loiret@u-psud.fr> implementing
    triarch support for MIPS (closes: #474097).

 -- Mark Brown <broonie@debian.org>  Sun, 06 Apr 2008 19:09:18 +0100

zlib (1:1.2.3.3.dfsg-11) unstable; urgency=low

  * Correct library names for cross libraries.
  * Turns out all our 64 bit architectures do off64_t.

 -- Mark Brown <broonie@debian.org>  Sat, 19 Jan 2008 22:33:06 +0000

zlib (1:1.2.3.3.dfsg-10) unstable; urgency=low

  * dpkg-shlibdeps doesn't deal well with unbuilt packages (closes: 461474).
  * Support packages using 64 bit cross symbols even when off_t is 64
    bits.

 -- Mark Brown <broonie@debian.org>  Fri, 18 Jan 2008 22:56:48 +0000

zlib (1:1.2.3.3.dfsg-9) unstable; urgency=low

  * Remove Debian revisions from symbol files.

 -- Mark Brown <broonie@debian.org>  Wed, 16 Jan 2008 10:53:27 +0000

zlib (1:1.2.3.3.dfsg-8) unstable; urgency=low

  * Add symbols files.  Version information is provided by the upstream
    map file.  Architecture lists may need some adjustment.
  * Fix udeb contents.
  * Policy 3.7.3 (no changes).

 -- Mark Brown <broonie@debian.org>  Sun, 16 Dec 2007 14:38:47 +0000



=== debian/control ===
Source: zlib
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
Standards-Version: 3.8.3
Homepage: http://zlib.net/
XS-VCS-Bzr: http://bzr.debian.org/bzr/pkg-zlib/zlib/debian
Build-Depends: debhelper (>= 6.0.7~), binutils (>= 2.18.1~cvs20080103-2) [mips mipsel], gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc], dpkg-dev (>= 1.16.0~ubuntu4)

Package: zlib1g
Architecture: any
Depends: ${shlibs:Depends}
Priority: required
Multi-Arch: same
Pre-Depends: multiarch-support
Conflicts: zlib1 (<= 1:1.0.4-7)
Provides: libz1
Description: compression library - runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the shared library.

Package: zlib1g-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: zlib1g (= ${binary:Version}), libc6-dev | libc-dev
Conflicts: zlib1-dev
Provides: libz-dev
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files.

Package: zlib1g-dbg
Section: debug
Priority: extra
Architecture: any
Depends: zlib1g (= ${binary:Version})
Provides: libz-dbg
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes debugging symbols for use
 when debugging applications which use zlib.

Package: zlib-bin
Section: utils
Architecture: any
Depends: ${shlibs:Depends}
Description: compression library - sample programs
 Some generally useful sample programs from the contrib directory.
 Includes a "mini" implementation of `zip' and `unzip' called
 `minizip' and `miniunzip' respectively.

Package: zlib1g-udeb
XC-Package-Type: udeb
Architecture: any
Priority: optional
Section: debian-installer
Description: compression library - runtime for Debian installer
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This minimal package includes the shared library
 for use with the Debian installer.

Package: lib64z1
Architecture: sparc s390 i386 powerpc mips mipsel
Depends: ${shlibs:Depends}
Replaces: amd64-libs (<< 1.4)
Description: compression library - 64 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 64 bit version of the
 shared library.

Package: lib64z1-dev
Section: libdevel
Architecture: sparc s390 i386 powerpc mips mipsel
Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev
Replaces: amd64-libs-dev (<< 1.4)
Provides: lib64z-dev
Description: compression library - 64 bit development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 64 bit applications.

Package: lib32z1
Architecture: amd64 ppc64 kfreebsd-amd64
Depends: ${shlibs:Depends}
Replaces: ia32-libs (<< 1.5)
Description: compression library - 32 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 32 bit version of the
 shared library.

Package: lib32z1-dev
Section: libdevel
Architecture: amd64 ppc64 kfreebsd-amd64
Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev
Provides: lib32z-dev
Replaces: ia32-libs-dev (<< 1.5)
Description: compression library - 32 bit development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 32 bit applications.

Package: libn32z1
Architecture: mips mipsel
Depends: ${shlibs:Depends}
Description: compression library - n32 runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a n32 version of the shared
 library.

Package: libn32z1-dev
Section: libdevel
Architecture: mips mipsel
Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev
Provides: libn32z-dev
Description: compression library - n32 development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building n32 applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULITARCH)

CFLAGS = -Wall -g -D_REENTRANT

# binutils doesn't supply the prefixed version normally like GCC does so
# we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	AR=ar
else
	AR=$(DEB_HOST_GNU_TYPE)-ar
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

64-ARCHS=s390 sparc i386 powerpc mips mipsel
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
EXTRA_INSTALL=install64
EXTRA_BUILD=build64-stamp
# MIPS doesn't use -m64
ifneq (,$(findstring $(DEB_HOST_ARCH), mips mipsel))
m64=-mabi=64
else
m64=-m64
endif
endif

32-ARCHS=amd64 ppc64 kfreebsd-amd64
ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
EXTRA_INSTALL=install32
EXTRA_BUILD=build32-stamp
m32=-m32
endif

N32-ARCHS=mips mipsel
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
EXTRA_INSTALL+=installn32
EXTRA_BUILD+=buildn32-stamp
mn32=-mabi=n32
endif

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(findstring $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

COPYLIST=*.h *.c *.in zlib.map configure zlib.3

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi
	if [ ! -f zlibdefs.h.stash ]; then cp zlibdefs.h zlibdefs.h.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

build: build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE)
	$(MAKE) CC=$(DEB_HOST_GNU_TYPE)-gcc OPT="$(CFLAGS)" -C contrib/minizip
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@

build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) -C contrib/minizip clean
	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz 
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	-mv Makefile.stash Makefile
	-mv zlibdefs.h.stash zlibdefs.h

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -s ChangeLog
	dh_installdocs -s
	dh_installexamples -s
	mkdir -p debian/tmp/usr/bin
	cp contrib/minizip/minizip debian/tmp/usr/bin
	cp contrib/minizip/miniunz debian/tmp/usr/bin/miniunzip
	dh_install -s --sourcedir=debian/tmp
	dh_installman -s
	dh_lintian -s
	dh_link -s
	dh_strip -s --dbg-package=zlib1g-dbg
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.2.5.dfsg

=== debian/changelog ===
zlib (1:1.2.5.dfsg-1) experimental; urgency=low

  * New upstream release.

 -- Mark Brown <broonie@debian.org>  Thu, 13 May 2010 11:21:01 +0100

zlib (1:1.2.3.5.dfsg-1) experimental; urgency=low

  * New upstream release.
  * Remove most of the contrib directory so we don't have to waste time
    writing a copyright file for code we don't build (closes: #561432).

 -- Mark Brown <broonie@debian.org>  Sun, 10 Jan 2010 22:27:09 +0000

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,6 @@
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
-DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULITARCH)
 
 CFLAGS = -Wall -g -D_REENTRANT
 
@@ -70,9 +69,8 @@
 	dh_testdir
 
 	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi
-	if [ ! -f zlibdefs.h.stash ]; then cp zlibdefs.h zlibdefs.h.stash ; fi
-
-	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+
+	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" uname=GNU ./configure --shared --prefix=/usr
 
 	touch $@
 
@@ -83,7 +81,7 @@
 	cp $(COPYLIST) debian/64
 	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
 	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
+	    uname=GNU ./configure --prefix=/usr  --libdir=\$${prefix}/usr/lib64
 	touch $@
 
 configure32-stamp: configure
@@ -93,7 +91,7 @@
 	cp $(COPYLIST) debian/32
 	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
 	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
+	    uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/usr/lib32
 	touch $@
 
 configuren32-stamp: configure
@@ -103,7 +101,7 @@
 	cp $(COPYLIST) debian/n32
 	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
 	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
+	    uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/usr/lib32
 	touch $@
 
 build: build-stamp $(EXTRA_BUILD)
@@ -143,7 +141,6 @@
 	rm -rf debian/32 build32-stamp configure32-stamp
 	rm -rf debian/n32 buildn32-stamp configuren32-stamp
 	-mv Makefile.stash Makefile
-	-mv zlibdefs.h.stash zlibdefs.h
 
 	dh_clean 
 
@@ -153,10 +150,7 @@
 	dh_clean -k 
 	dh_installdirs
 
-	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
-	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
-	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
-	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so
+	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install
 
 install64: install build64-stamp
 	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

## zlib 1.2.7.dfsg

=== debian/changelog ===
zlib (1:1.2.7.dfsg-13ubuntu2) raring; urgency=low

  * Move zconf.h to multiarch location as it's not (quite) arch-independent
    (LP: #1102602).

 -- Wookey <wookey@wookware.org>  Thu, 07 Feb 2013 12:28:30 +0000

zlib (1:1.2.7.dfsg-13ubuntu1) raring; urgency=low

  * Build x32 packages.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Nov 2012 10:49:45 +0100

zlib (1:1.2.7.dfsg-13) unstable; urgency=low

  * Yet more s390x cleanup.  Thanks to the s390x porters for thei
    prompt an efficient buildd monitoring (closes: #678511).

 -- Mark Brown <broonie@debian.org>  Fri, 22 Jun 2012 16:55:56 +0100

zlib (1:1.2.7.dfsg-12) unstable; urgency=low

  * Clean up breakage from binnmu since with multiarch binnmus of zlib
    and other multiarch enabled library packages aren't actually
    installable.  Hopefully the multiarch people will get round to
    cleaning up the infrastructure at some point (closes: #678172).

 -- Mark Brown <broonie@debian.org>  Wed, 20 Jun 2012 10:00:42 +0100

zlib (1:1.2.7.dfsg-11) unstable; urgency=low

  * Third time lucky.  I love double negative logic on strings.  It's a
    shame the patch for s390x didn't take care of s390...

 -- Mark Brown <broonie@debian.org>  Tue, 22 May 2012 14:07:04 +0100

zlib (1:1.2.7.dfsg-10) unstable; urgency=low

  * Nope, here we go again... 

 -- Mark Brown <broonie@debian.org>  Tue, 22 May 2012 11:22:36 +0100

zlib (1:1.2.7.dfsg-9) unstable; urgency=low

  * Let's try a different bodge for s390...

 -- Mark Brown <broonie@debian.org>  Tue, 22 May 2012 10:07:49 +0100

zlib (1:1.2.7.dfsg-8) unstable; urgency=low

  * Yet another special case for s390.

 -- Mark Brown <broonie@debian.org>  Mon, 21 May 2012 23:58:53 +0100

zlib (1:1.2.7.dfsg-7) unstable; urgency=low

  * Fix cross 32 builds.

 -- Mark Brown <broonie@debian.org>  Mon, 21 May 2012 15:20:02 +0100

zlib (1:1.2.7.dfsg-6) unstable; urgency=low

  * Pass LDFLAGS to minizip too, but don't bother with TEST_LDFLAGS
    for the main build since it accomplishes nothing (closes: #672310).
  * Disallow simutaneous 64 and 32 bit cross package builds.

 -- Mark Brown <broonie@debian.org>  Mon, 21 May 2012 10:25:15 +0100

zlib (1:1.2.7.dfsg-5) unstable; urgency=low

  * s390x doesn't actually have 32 bit, only 31 bit, and making the
    compiler options consistent is too hard. 

 -- Mark Brown <broonie@debian.org>  Sun, 20 May 2012 22:55:16 +0100

zlib (1:1.2.7.dfsg-4) unstable; urgency=low

  * Move primary shared library to /lib for wpa_supplicant (closes: #591013).

 -- Mark Brown <broonie@debian.org>  Sun, 20 May 2012 16:39:00 +0100

zlib (1:1.2.7.dfsg-3) unstable; urgency=low

  * Clean up ironic breakage in patch for hardening (closes: #672310).
  * Support biarch on s390x (closes: #637898).

 -- Mark Brown <broonie@debian.org>  Sun, 20 May 2012 16:17:27 +0100

zlib (1:1.2.7.dfsg-2) unstable; urgency=low

  * Enable hardening flags, yet another release goal which we've
    suddenly decided to start work on close to the end of the release
    cycle.  Patch from Moritz Mühlenhoff (closes: #672310).

 -- Mark Brown <broonie@debian.org>  Sat, 19 May 2012 19:52:14 +0100

zlib (1:1.2.7.dfsg-1) unstable; urgency=low

  * New upstream release.

 -- Mark Brown <broonie@debian.org>  Thu, 03 May 2012 10:08:05 +0100

zlib (1:1.2.6.dfsg-2) unstable; urgency=low

  * Break texlive-binaries before 2009-12 due to gzeof() behaviour
    change (closes: #659681).

 -- Mark Brown <broonie@debian.org>  Thu, 23 Feb 2012 23:28:27 +0000

zlib (1:1.2.6.dfsg-1) unstable; urgency=low

  * New upstream release.
  * OMG!!!!! MULTIARCH!!!#!!! (closes: #569697).
  * Break older libxml (closes: #589134).
  * Drop bzr repo, it's adding nothing and painful to use.

 -- Mark Brown <broonie@debian.org>  Sun, 12 Feb 2012 02:05:41 +0000

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
 Standards-Version: 3.8.3
 Homepage: http://zlib.net/
-XS-VCS-Bzr: http://bzr.debian.org/bzr/pkg-zlib/zlib/debian
-Build-Depends: debhelper (>= 6.0.7~), binutils (>= 2.18.1~cvs20080103-2) [mips mipsel], gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc], dpkg-dev (>= 1.16.0~ubuntu4)
+Build-Depends: debhelper (>= 8.1.3~), binutils (>= 2.18.1~cvs20080103-2) [mips mipsel], gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x], dpkg-dev (>= 1.16.0)
 
 Package: zlib1g
 Architecture: any
-Depends: ${shlibs:Depends}
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Priority: required
-Multi-Arch: same
-Pre-Depends: multiarch-support
 Conflicts: zlib1 (<= 1:1.0.4-7)
+Breaks: libxml2 (<< 2.7.6.dfsg-2), texlive-binaries (<< 2009-12)
 Provides: libz1
 Description: compression library - runtime
  zlib is a library implementing the deflate compression method found
@@ -24,7 +24,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: zlib1g (= ${binary:Version}), libc6-dev | libc-dev
+Depends: zlib1g (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
 Conflicts: zlib1-dev
 Provides: libz-dev
 Description: compression library - development
@@ -46,7 +46,7 @@
 Package: zlib-bin
 Section: utils
 Architecture: any
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: compression library - sample programs
  Some generally useful sample programs from the contrib directory.
  Includes a "mini" implementation of `zip' and `unzip' called
@@ -64,7 +64,7 @@
 
 Package: lib64z1
 Architecture: sparc s390 i386 powerpc mips mipsel
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: amd64-libs (<< 1.4)
 Description: compression library - 64 bit runtime
  zlib is a library implementing the deflate compression method found
@@ -74,7 +74,7 @@
 Package: lib64z1-dev
 Section: libdevel
 Architecture: sparc s390 i386 powerpc mips mipsel
-Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev
+Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
 Replaces: amd64-libs-dev (<< 1.4)
 Provides: lib64z-dev
 Description: compression library - 64 bit development
@@ -83,8 +83,9 @@
  files for building 64 bit applications.
 
 Package: lib32z1
-Architecture: amd64 ppc64 kfreebsd-amd64
-Depends: ${shlibs:Depends}
+Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Conflicts: libc6-i386 (<= 2.9-18)
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: ia32-libs (<< 1.5)
 Description: compression library - 32 bit runtime
  zlib is a library implementing the deflate compression method found
@@ -93,8 +94,9 @@
 
 Package: lib32z1-dev
 Section: libdevel
-Architecture: amd64 ppc64 kfreebsd-amd64
-Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev
+Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Conflicts: libc6-i386 (<= 2.9-18)
+Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
 Provides: lib32z-dev
 Replaces: ia32-libs-dev (<< 1.5)
 Description: compression library - 32 bit development
@@ -104,7 +106,7 @@
 
 Package: libn32z1
 Architecture: mips mipsel
-Depends: ${shlibs:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: compression library - n32 runtime
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes a n32 version of the shared
@@ -113,9 +115,27 @@
 Package: libn32z1-dev
 Section: libdevel
 Architecture: mips mipsel
-Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev
+Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev, ${misc:Depends}
 Provides: libn32z-dev
 Description: compression library - n32 development
  zlib is a library implementing the deflate compression method found
  in gzip and PKZIP.  This package includes the development support
  files for building n32 applications.
+
+Package: libx32z1
+Architecture: amd64 i386
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Description: compression library - x32 runtime
+ zlib is a library implementing the deflate compression method found
+ in gzip and PKZIP.  This package includes a n32 version of the shared
+ library.
+
+Package: libx32z1-dev
+Section: libdevel
+Architecture: amd64 i386
+Depends: libx32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libc6-dev-x32, ${misc:Depends}
+Provides: libx32z-dev
+Description: compression library - x32 development
+ zlib is a library implementing the deflate compression method found
+ in gzip and PKZIP.  This package includes the development support
+ files for building n32 applications.

=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,10 @@
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
-
-CFLAGS = -Wall -g -D_REENTRANT
+DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
+LDFLAGS = `dpkg-buildflags --get LDFLAGS`
 
 # binutils doesn't supply the prefixed version normally like GCC does so
 # we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
@@ -32,7 +34,22 @@
 	CFLAGS += -O3
 endif
 
+32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
 64-ARCHS=s390 sparc i386 powerpc mips mipsel
+
+ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
+EXTRA_INSTALL=install32
+EXTRA_BUILD=build32-stamp
+# s390x fails at compatibility.
+ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
+m32=-m31
+else
+m32=-m32
+endif
+endif
+
+ifneq (,$(findstring s390x, $(DEB_HOST_ARCH)))
+else
 ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
 EXTRA_INSTALL=install64
 EXTRA_BUILD=build64-stamp
@@ -43,12 +60,6 @@
 m64=-m64
 endif
 endif
-
-32-ARCHS=amd64 ppc64 kfreebsd-amd64
-ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
-EXTRA_INSTALL=install32
-EXTRA_BUILD=build32-stamp
-m32=-m32
 endif
 
 N32-ARCHS=mips mipsel
@@ -58,19 +69,26 @@
 mn32=-mabi=n32
 endif
 
+X32-ARCHS=amd64 i386
+ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
+EXTRA_INSTALL+=installx32
+EXTRA_BUILD+=buildx32-stamp
+mx32=-mx32
+endif
+
 UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
 ifneq (,$(findstring $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
 CFLAGS+=-DUNALIGNED_OK
 endif
 
-COPYLIST=*.h *.c *.in zlib.map configure zlib.3
+COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test
 
 configure-stamp: configure
 	dh_testdir
 
 	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi
 
-	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" uname=GNU ./configure --shared --prefix=/usr
+	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 
 	touch $@
 
@@ -78,30 +96,40 @@
 	dh_testdir
 
 	mkdir -p debian/64
-	cp $(COPYLIST) debian/64
+	cp -r $(COPYLIST) debian/64
 	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
-	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --prefix=/usr  --libdir=\$${prefix}/usr/lib64
+	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
 	touch $@
 
 configure32-stamp: configure
 	dh_testdir
 
 	mkdir -p debian/32
-	cp $(COPYLIST) debian/32
+	cp -r $(COPYLIST) debian/32
 	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
-	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/usr/lib32
+	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
 	touch $@
 
 configuren32-stamp: configure
 	dh_testdir
 
 	mkdir -p debian/n32
-	cp $(COPYLIST) debian/n32
+	cp -r $(COPYLIST) debian/n32
 	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
-	    CFLAGS="$(CFLAGS)" \
-	    uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/usr/lib32
+	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
+	touch $@
+
+configurex32-stamp: configure
+	dh_testdir
+
+	mkdir -p debian/x32
+	cp -r $(COPYLIST) debian/x32
+	cd debian/x32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mx32)" \
+	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
+	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/libx32
 	touch $@
 
 build: build-stamp $(EXTRA_BUILD)
@@ -109,7 +137,7 @@
 	dh_testdir
 
 	$(MAKE)
-	$(MAKE) CC=$(DEB_HOST_GNU_TYPE)-gcc OPT="$(CFLAGS)" -C contrib/minizip
+	$(MAKE) CC=$(DEB_HOST_GNU_TYPE)-gcc CFLAGS="-I../.. $(CFLAGS)" LDFLAGS="$(LDFLAGS)" -C contrib/minizip
 	-$(MAKE) test
 
 	touch $@
@@ -127,6 +155,11 @@
 buildn32-stamp: configuren32-stamp
 	dh_testdir
 	make -C debian/n32
+	touch $@
+
+buildx32-stamp: configurex32-stamp
+	dh_testdir
+	make -C debian/x32
 	touch $@
 
 clean:
@@ -140,7 +173,9 @@
 	rm -rf debian/64 build64-stamp configure64-stamp
 	rm -rf debian/32 build32-stamp configure32-stamp
 	rm -rf debian/n32 buildn32-stamp configuren32-stamp
+	rm -rf debian/x32 buildx32-stamp configurex32-stamp
 	-mv Makefile.stash Makefile
+	-mv zlibdefs.h.stash zlibdefs.h
 
 	dh_clean 
 
@@ -152,6 +187,11 @@
 
 	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install
 
+	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH) debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)
+	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
+	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so
+	mv debian/tmp/usr/include/zconf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/
+
 install64: install build64-stamp
 	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install
 
@@ -160,6 +200,9 @@
 
 installn32: install buildn32-stamp
 	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install
+
+installx32: install buildx32-stamp
+	$(MAKE) -C debian/x32 prefix=$(CURDIR)/debian/tmp install
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -183,14 +226,19 @@
 	dh_compress -s
 	dh_fixperms -s
 	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
+ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
+	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
+endif
+ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
 ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
 	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
 endif
-ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
-	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
 endif
 ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
 	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
+endif
+ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
+	dh_makeshlibs -plibx32z1 -V"libx32z1 (>= 1:1.2.3.3.dfsg-1)"
 endif
 	dh_installdeb -s
 	dh_shlibdeps -s
